<?php 
// FModControl v2.0.0 Copyright (c) Igor Anikeev https://webnav.link/ 2016 - 2024.
?><?php
class browse{

public $fnames_alternate_charset = 'iso-8859-1';


public function listFiles($dirname){
global $lang;
require_once(INC_DIR.'/charset_conv_simple.php');
$dirname = base64_decode($dirname);
 if(empty($dirname)){
 $dirname = getenv('DOCUMENT_ROOT');
 }
$dirname = $this->realfname($dirname);
if(! is_dir($dirname)){return 'Empty dirname';}

$ret = '';

$delimiter = '/';
 if($dirname == '/'){
 $delimiter = '';
 }

$folders = array();
$files = array();

$dh = @opendir($dirname) or die('Cannot open dir '.$dirname);
 while(($file = readdir($dh)) !== false){
  if(@is_file("$dirname$delimiter$file")){
   array_push($files, $file);
  }
  elseif(@is_dir("$dirname$delimiter$file") && ! @is_link("$dirname$delimiter$file")){
  array_push($folders, $file);
  }

 }
closedir($dh);

sort($folders);

$parent_exists = false;
 for($i = 0; $i <= count($folders); $i++){
  if(isset($folders[$i]) && ($folders[$i] == '.' || $folders[$i] == '..')){
   if($folders[$i] == '..'){
   $parent_exists = true;
   }
  unset($folders[$i]);
  }
 }

array_unshift($folders, '.');
 if($parent_exists){
 array_unshift($folders, '..');
 }

 if(! in_array('..', $folders)){
 $open_basedir = @ini_get('open_basedir');
  if($open_basedir){
  $ret .= "$lang[Access_to_higher_level_limited_by_directive] php.ini open_basedir = $open_basedir<br>";
  }
 }

$ret .= "<table class=\"settbl\"><tr class=\"htr\"><td>$lang[Directories]</td></tr>";

$cbid = 0;

 if(count($folders)){

  foreach($folders as $value){

  $img_file = 'folder.gif';
  $title = $this->autoCharset($value);
   if($value == '..'){
   $title = "$value $lang[one_level_up]";
   }

  $fullname = $this->realfname($dirname.$delimiter.$value);
  $value_fullname = $this->encodeCharsetToHex($fullname);
  $chkclass = 'browseChk';
  $link = '<a href="?view=browse&amp;bdr='.urlencode(base64_encode($fullname))."&amp;independ=1\">$title</a>";
  $onclick = 'unselParent(this);';

   if($value == '..'){
   $img_file = 'parent_folder.gif';
   }
   elseif($value == '.'){
   $chkclass = 'browseChk browseChkLeft';
   $link = $this->autoCharset($fullname);
   $onclick = 'unselChilds(this);';
   }

  $checkbox = '';
   if($value != '..'){
   $checkbox = "<span class=\"$chkclass\"><input type=\"checkbox\" id=\"selfiles$cbid\" value=\"$value_fullname\" onclick=\"updateVals(this);\"></span>";
   $cbid ++;
   }

   $stclass = usual::stclass();
   $ret .=  "<tr class=\"$stclass\"><td>$checkbox<img src=\"adm/img/$img_file\" width=\"15\" height=\"13\" alt=\"\" class=\"browseImg\">$link</td></tr>\n";

  }
 }

$ret .= "<tr class=\"htr\"><td>$lang[Files]</td></tr>";


$onclick = 'unselParent(this);';

 if(count($files)){
  foreach($files as $value){
  $fullname = $this->realfname($dirname.$delimiter.$value);
  $value_fullname = $this->encodeCharsetToHex($fullname);
  $title = $this->autoCharset($value);
  $stclass = usual::stclass();
  $ret .=  "<tr class=\"$stclass\"><td><span class=\"browseChk\"><input type=\"checkbox\" id=\"selfiles$cbid\" value=\"$value_fullname\" onclick=\"updateVals(this);\"></span><img src=\"adm/img/file.gif\" width=\"9\" height=\"11\" alt=\"\" class=\"browseImg\">$title</td></tr>\n";
  $cbid ++;
  }
 }

$ret .= '</table>';

return $ret.'<br>';
}



public function encodeCharsetToHex($file){
 if(! preg_match('/./u', $file)){
 $file = preg_replace_callback('/[\x80-\xFF]/', array($this, 'calbk1'), $file);
 }
return $file;
}


private function calbk1($matches){
$char = dechex(ord($matches[0]));
 if(strlen($char) == 1){
 $char = '0'.$char;
 }
return '[#'.$char.']';
}


private function autoCharset($str){
 if(! preg_match('/./u', $str)){
 return charsetConvSimple::recode_str($str, $this->fnames_alternate_charset, 'utf-8');
 }
return $str;
}



private function realfname($file){
$name = str_replace('\\', '/', @realpath($file));
 if(substr($name, 1, 2) == ':/'){
 $name = substr($name, 2);
 }
return $name;
}



}
?>
