<?php 
// FModControl v2.0.0 Copyright (c) Igor Anikeev https://webnav.link/ 2016 - 2024.
?><?php
if(! defined('SYS_LOADER')){die();}
global $act, $log_fields;

$lfile = '';
 if(isset($_GET['lfile']) && lg_isLogFile($_GET['lfile'])){
 $lfile = $_GET['lfile'];
 }

 switch($act){
 case 'download':
 echo lg_download_log($lfile);
 break;

 case 'show_log':
 echo lg_show_log($lfile);
 break;

 case 'delete':
 echo lg_delete_log($lfile);

 default:
 echo lg_list_logs();
 }



function lg_list_logs(){
global $lang;
$ret = "<div><h1 style=\"display:inline;\">$lang[Check_results]</h1> " . usual::contextHelp($lang['Check_results_help']).'</div>';
$ret .= <<<HTMLDATA
<table class="settbl">
 <tr class="htr">
  <td>$lang[File_View]</td>
  <td>$lang[Download]</td>
  <td class="alignCenter">$lang[Delete]</td>
 </tr>
HTMLDATA;
$files = array();
$dh = opendir(DATA_DIR) or die('Cannot open dir $1');
 while(($filename = readdir($dh)) !== false){
  if(lg_isLogFile($filename)){
  array_push($files, $filename);
  }
 }
closedir($dh);
rsort($files);

 if(count($files) > 0){
  foreach($files as $filename){
  $def_class = usual::stclass();
  $ret .= <<<HTMLDATA
<tr class="$def_class">
 <td><a href="?view=logs&amp;act=show_log&amp;lfile=$filename&amp;independ=1" target="_blank">$filename</a></td>
 <td class="alignCenter"><a href="?view=logs&amp;act=download&amp;lfile=$filename&amp;independ=1"><img src="adm/img/download.gif" alt="$lang[Download]" title="$lang[Download]"></a></td>
 <td class="alignCenter"><a href="?view=logs&amp;act=delete&amp;lfile=$filename" onclick="return q('$lang[delete_this_file]');"><img src="adm/img/del.gif" alt="$lang[Delete]" title="$lang[Delete]"></a></td>
</tr>
HTMLDATA;
  }
 }
 else{
 $ret .= "<tr><td colspan=\"3\">$lang[There_are_no_log_files]</td></tr>";
 }
$ret .= '</table>';
return $ret;
}


function lg_isLogFile($filename){
return preg_match('#^\d\d\d\d-\d\d-\d\d\_\d\d-\d\d-\d\d\.(log|txt){1,1}(\.gz){0,1}$#', $filename);
}


function lg_is_valid_logfile($file){
 if(strpos($file, '..') !== false || strpos($file, '/') !== false || strpos($file, '\\') !== false){
 return false;
 }
 if(substr($file, strlen($file)-4, 4) != '.log' && substr($file, strlen($file)-4, 4) != '.txt' && substr($file, strlen($file)-7, 7) != '.log.gz' && substr($file, strlen($file)-7, 7) != '.txt.gz'){
 return false;
 }
return true;
}


function lg_download_log($file){
 if($file === '' || ! lg_is_valid_logfile($file)){
 return 'Invalid filename';
 }
header("Pragma: no-cache");
header("Cache-Control: no-cache, must-revalidate");
header("Expires: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Content-Type: application/octet-stream; name=\"$file\"");
header("Content-disposition: attachment; filename=$file");
 if(is_file(DATA_DIR."/$file")){
 return file_get_contents(DATA_DIR."/$file");
 }
}


function lg_show_log($logfile){
global $lang;

 if($logfile === '' || ! lg_is_valid_logfile($logfile)){
 return 'Invalid filename';
 }
 if(! is_file(DATA_DIR."/$logfile")){
 return 'File not found: '.$logfile;
 }

require_once(INC_DIR.'/charset_conv_simple.php');

 if(substr($logfile, strlen($logfile)-3, 3) == '.gz'){
 $data = lg_gzGetContents(DATA_DIR."/$logfile");
 }
 else{
 $data = file_get_contents(DATA_DIR."/$logfile");
 }
$data = str_replace("\x0D", '', $data);
$new_files = lg_parse_new_files($data);
$changed_files = lg_parse_changed_files($data);
$errors = lg_parse_errors($data);
unset($data);

$ret = "<h1>$lang[Scan_log] $logfile</h1>";

$mtime_help = usual::contextHelp("$lang[log_mtime] (mtime)", 'chelp-blue_matte.gif');
$size_help = usual::contextHelp("$lang[log_size] (size)", 'chelp-blue_matte.gif');
$mode_help = usual::contextHelp("$lang[log_mode] (mode)", 'chelp-blue_matte.gif');
$ctime_help = usual::contextHelp("$lang[log_ctime]", 'chelp-blue_matte.gif');
$hash_help = usual::contextHelp("$lang[log_hash]", 'chelp-blue_matte.gif');
$uid_help = usual::contextHelp("$lang[log_uid] (uid)", 'chelp-blue_matte.gif');
$gid_help = usual::contextHelp("$lang[log_gid] (gid)", 'chelp-blue_matte.gif');

 if(count($new_files)){
 $ret .= <<<HTMLDATA
<h2>$lang[New_files]</h2>
<table class="settbl logsTbl">
 <tr class="htr">
  <td>$lang[file_Changed] $mtime_help</td>
  <td>$lang[file_Size] $size_help</td>
  <td>$lang[file_Attributes] $mode_help</td>
  <td>$lang[file_Inode_date] $ctime_help</td>
  <td>$lang[file_Hash] $hash_help</td>
  <td>$lang[file_Owner] $uid_help</td>
  <td>$lang[file_Group] $gid_help</td>
 </tr>
HTMLDATA;

  foreach($new_files as $file){
  $img = lg_fileImg($file['fname']);
  $file['fname'] = usual::replace_tags_and_quotes(lg_autoCharset($file['fname']));
  $new = $file['new'];
  $ret .= <<<HTMLDATA
 <tr class="ttr">
  <td colspan="7">$img$file[fname]</td>
 </tr>
 <tr>
  <td>$new[mtime]</td>
  <td class="alignCenter">$new[size]</td>
  <td class="alignCenter">$new[mode]</td>
  <td>$new[ctime]</td>
  <td>$new[md5]</td>
  <td class="alignCenter">$new[uid]</td>
  <td class="alignCenter">$new[gid]</td>
 </tr>
 <tr>
  <td colspan="7"><hr></td>
 </tr>
HTMLDATA;
  }

 $ret .= '</table><br><hr><br>';
 }


 if(count($changed_files)){
 $ret .= <<<HTMLDATA
<h2>$lang[Modified_files]</h2>
<table class="settbl logsTbl">
 <tr class="htr">
  <td>&nbsp;</td>
  <td>$lang[file_Changed] $mtime_help</td>
  <td>$lang[file_Size] $size_help</td>
  <td>$lang[file_Attributes] $mode_help</td>
  <td>$lang[file_Inode_date] $ctime_help</td>
  <td>$lang[file_Hash] $hash_help</td>
  <td>$lang[file_Owner] $uid_help</td>
  <td>$lang[file_Group] $gid_help</td>
 </tr>
HTMLDATA;

  foreach($changed_files as $file){
  $img = lg_fileImg($file['fname']);
  $file['fname'] = usual::replace_tags_and_quotes(lg_autoCharset($file['fname']));
  $new = $file['new'];
  $old = $file['old'];
  $ret .= <<<HTMLDATA
 <tr class="ttr">
  <td colspan="8">$img$file[fname]</td>
 </tr>
 <tr>
  <td>$lang[New_data]</td>
  <td>$new[mtime]</td>
  <td class="alignCenter">$new[size]</td>
  <td class="alignCenter">$new[mode]</td>
  <td>$new[ctime]</td>
  <td>$new[md5]</td>
  <td class="alignCenter">$new[uid]</td>
  <td class="alignCenter">$new[gid]</td>
 </tr>
 <tr>
  <td>$lang[Previous_data]</td>
  <td>$old[mtime]</td>
  <td class="alignCenter">$old[size]</td>
  <td class="alignCenter">$old[mode]</td>
  <td>$old[ctime]</td>
  <td>$old[md5]</td>
  <td class="alignCenter">$old[uid]</td>
  <td class="alignCenter">$old[gid]</td>
 </tr>
 <tr>
  <td colspan="8"><hr></td>
 </tr>
HTMLDATA;
  }

 $ret .= '</table><br><hr><br>';
 }


 if(count($errors)){
 $ret .= <<<HTMLDATA
<h2>$lang[Errors]</h2>
<table class="settbl logsTbl">
 <tr class="htr">
  <td>&nbsp;</td>
 </tr>
HTMLDATA;

  foreach($errors as $str){
  $stlass = usual::stclass();
  $ret .= <<<HTMLDATA
 <tr class="$stlass">
  <td>$str</td>
 </tr>
HTMLDATA;
  }

 $ret .= '</table><br><hr><br>';
 }

$cnt_new = count($new_files);
$cnt_changed = count($changed_files);
$cnt_total = $cnt_new + $cnt_changed;
$cnt_errors = count($errors);

return <<<HTMLDATA
<!DOCTYPE html>
<html><head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<title>$logfile</title>
<link href="adm/admin.css" rel="stylesheet" type="text/css">
</head>
<body style="padding:4px;">
$ret
<p>
$lang[res_cnt_New_files] $cnt_new<br>
$lang[res_cnt_Modified_files]  $cnt_changed<br>
$lang[res_cnt_Total_new_and_modified]  $cnt_total<br>
$lang[res_cnt_Errors]  $cnt_errors<br>
</p>
</body></html>
HTMLDATA;
}


function lg_parse_new_files($data){
preg_match('/\[NewFiles\](.*)\[\/NewFiles\]/s', $data, $matches);
 if(! isset($matches[1])){
 return array();
 }
$new_files = array();
$lines = explode("\x0A", $matches[1]);
 if(count($lines)){
  foreach($lines as $str){
  $str = trim($str);
   if($str !== ''){
   $line = lg_explodeRight(' |', $str);
   $fields = explode(';', $line[1]);

   $arr = lg_new_fields_array();
    foreach($fields as $fline){
    $field = explode('=', $fline);
    $field[0] = trim($field[0]);
     if($field[0] !== ''){
     $arr["$field[0]"] = trim($field[1]);
     }
    }

   array_push($new_files, array('fname' => $line[0], 'new' => $arr));
   }
  }
 }
return $new_files;
}




function lg_parse_changed_files($data){
preg_match('/\[ChangedFiles\](.*)\[\/ChangedFiles\]/s', $data, $matches);
 if(! isset($matches[1])){
 return array();
 }
$changed_files = array();
$lines = explode("\x0A", $matches[1]);
 if(count($lines)){
  foreach($lines as $str){
  $str = trim($str);
   if($str !== ''){

   $line = lg_explodeRight(' |', $str);
   $old_new = explode('New: ', $line[1]);
   $old_new = explode(' Old: ', $old_new[1]);

   $new_fields = explode(';', $old_new[0]);
   $arr_new = lg_new_fields_array();
    foreach($new_fields as $fline){
    $field = explode('=', $fline);
    $field[0] = trim($field[0]);
     if($field[0] !== ''){
     $arr_new["$field[0]"] = trim($field[1]);
     }
    }

   $old_fields = explode(';', $old_new[1]);
   $arr_old = lg_new_fields_array();
    foreach($old_fields as $fline){
    $field = explode('=', $fline);
    $field[0] = trim($field[0]);
     if($field[0] !== ''){
     $arr_old["$field[0]"] = trim($field[1]);
     }
    }

   array_push($changed_files, array('fname' => $line[0], 'old' => $arr_old, 'new' => $arr_new));
   }
  }
 }
return $changed_files;
}



function lg_parse_errors($data){
preg_match('/\[Errors\](.*)\[\/Errors\]/s', $data, $matches);
 if(! isset($matches[1])){
 return array();
 }
$errors = array();
$lines = explode("\x0A", $matches[1]);
 if(count($lines)){
  foreach($lines as $str){
  $str = trim($str);
   if($str !== ''){
   array_push($errors, $str);
   }
  }
 }
return $errors;
}



function lg_delete_log($file){
global $lang;
 if($file === '' || ! lg_is_valid_logfile($file)){
 return 'Invalid filename';
 }
 if(is_file(DATA_DIR."/$file")){
  if(@unlink(DATA_DIR."/$file")){
  return msg::success($file, $lang['File_deleted']);
  }
  else{
  return msg::error($lang['Failed_delete_file'] . ' ' . DATA_DIR."/$file");
  }
 }
}


function lg_gzGetContents($file){
$data = '';
$fh = gzopen($file, 'rb') or die('Cannot open file '.$file);
 while(! gzeof($fh)){
 $data .= gzgets($fh);
 }
gzclose($fh);
return $data;
}


function lg_explodeRight($delim, $str){
$pos = strrpos($str, $delim);
 if($pos === false){
 return array($str);
 }
return array(substr($str, 0, $pos), substr($str, $pos + strlen($delim)));
}


function lg_new_fields_array(){
return array('mode' => 0, 'uid' => 0, 'gid' => 0, 'size' => 0, 'mtime' => '', 'ctime' => '', 'md5' => '');
}


function lg_autoCharset($str){
global $conf;
 if(! preg_match('/./u', $str)){
 return charsetConvSimple::recode_str($str, $conf['fnames_alternate_charset'], 'utf-8');
 }
return $str;
}


function lg_fileImg($file){
global $lang;
$img = '';
 if(@is_file($file)){
 $img = '<img src="adm/img/file.gif" width="9" height="11" alt="" title="' . $lang['File'] . '" class="browseImg">';
 }
 elseif(@is_dir($file)){
 $img = '<img src="adm/img/folder.gif" width="15" height="13" alt="" title="' . $lang['Directory'] . '" class="browseImg">';
 }
 elseif(! @file_exists($file)){
 $img = '<img src="adm/img/deleted.gif" width="14" height="14" alt="" title="' . $lang['Does_not_exist_now'] . '" class="browseImg">';
 }
return $img;
}

?>