<?php 
// FModControl v2.0.0 Copyright (c) Igor Anikeev https://webnav.link/ 2016 - 2024.
?><?php
class mailer{

public $content_type = 'text/plain';
public $charset = 'utf-8';
public $time_diff = 0;
public $data_dir = '';
public $smtp_conf = array();
public $crlf = '';
private $adv_headers = array();


public function __construct($params = array()){
$this->clear_headers();

$this->crlf = "\r\n";
 if(count($params)){
  foreach($params as $key => $value){
   if(isset($this->$key)){
   $this->$key = $value;
   }
  }
 }
}


public function sendemail($from_name, $from_email, $to_name, $to_email, $subject, $message, $attach_files = array()){
$date = date("H:i:s d.m.Y", time() + $this->time_diff * 3600);

 if(! empty($this->data_dir) && ! $this->is_valid_email($from_email)){
 $this->add_tolog($this->data_dir.'/err_mail.log', "$date Invalid FROM email: $from_email\n");
 return false;
 }

 if(! empty($this->data_dir) && ! $this->is_valid_email($to_email)){
 $this->add_tolog($this->data_dir.'/err_mail.log', "$date Invalid TO email: $to_email\n");
 return false;
 }

 if($from_name){
 $from_name = $this->encode_name_subject($from_name);
 }

 if($to_name){
 $to_name = $this->encode_name_subject($to_name);
 }

 if($subject){
 $subject = $this->encode_name_subject($subject);
 }

$from = $from_email;
$to = $to_email;

 if(! $this->is_windows() || (defined('DEBUG_MODE') && DEBUG_MODE == 1)){
  if($from_name){
  $from = "$from_name <$from_email>";
  }
  if($to_name){
  $to = "$to_name <$to_email>";
  }
 }

$subject = stripslashes($subject);
$message = stripslashes($message);

$message = str_replace('&quot;', '"', $message);
$message = str_replace('&#39;', "'", $message);
$message = str_replace('&#96;', "`", $message);

$message = str_replace('&lt;', '<', $message);
$message = str_replace('&gt;', '>', $message);

 if(! $this->is_windows()){
 $message = str_replace("\x0D", '', $message);
 }

$headers = 'From: '.$from.$this->crlf;
 if(count($this->smtp_conf)){
 $headers .= 'To: '.$to.$this->crlf;
 $headers .= 'Subject: '.$subject.$this->crlf;
 }
$headers .= 'Date: ' . date('r', time() + $this->time_diff * 3600) . $this->crlf;


 if(count($this->adv_headers)){
  foreach($this->adv_headers as $def_hdr){
  $def_hdr = str_replace("\r\n", "\n", $def_hdr);
  $def_hdr = str_replace("\r", "\n", $def_hdr);
  $def_hdr = str_replace("\n", $this->crlf, $def_hdr);
  $headers .= $def_hdr . $this->crlf;
  }
 }


$body = '';

 if(sizeof($attach_files)){
 $boundary = $this->generate_boundary();
 $headers .= "MIME-Version: 1.0$this->crlf";
 $headers .= "Content-Type: multipart/mixed;$this->crlf";
 $headers .= " boundary=\"$boundary\"$this->crlf$this->crlf";

 $body .= "--$boundary$this->crlf";
 $body .= "Content-Type: $this->content_type; charset=$this->charset$this->crlf";
 $body .= "Content-Transfer-Encoding: base64$this->crlf$this->crlf";
 $body .= $this->split_base64_text(base64_encode($message))."$this->crlf$this->crlf";

  foreach($attach_files as $file){
   if(is_file($file)){
   $body .= "--$boundary$this->crlf";
   $body .= "Content-Type: application/octet-stream;$this->crlf";
   $only_filename = $this->get_filename_from_full_path($file);
   $body .= " name=\"$only_filename\"$this->crlf";
   $body .= "Content-Transfer-Encoding: base64$this->crlf";
   $body .= "Content-Disposition: attachment;$this->crlf";
   $body .= " filename=\"$only_filename\"$this->crlf$this->crlf";
   $body .= $this->split_base64_text(base64_encode(file_get_contents($file)))."$this->crlf$this->crlf";
   }
  }

 }
 else{
 $headers .= "Content-type: $this->content_type; charset=$this->charset$this->crlf";
 $headers .= "Content-Transfer-Encoding: base64$this->crlf";
 $body = $this->split_base64_text(base64_encode($message));
 }

 if(count($this->smtp_conf)){
 require_once('smtp.php');
 $smtp = new smtp($this->smtp_conf);
 $smtp_params = array(
 'from' => $from_email,
 'to_adrs' => $to_email,
 'headers' => explode($this->crlf, $headers),
 'body' => $body,
 );
 $send_result = $smtp->mail_send($smtp_params);
  if(defined('DEBUG_MODE') && DEBUG_MODE == 1){
  echo 'SMTP Error:<br>';
  print_r($smtp->errors);
  }
 }
 else{
 $send_result = @mail($to, $subject, $body, $headers);
 }

 if(! empty($this->data_dir) && ! $send_result){
 $this->add_tolog($this->data_dir.'/err_mail.log', "$date Cannot send mail: From: $from To: $to Subject: $subject\n");
 }

 if(defined('DEBUG_MODE') && DEBUG_MODE == 1){
 $headers = str_replace('<','&lt;',$headers);
 $headers = str_replace('>','&gt;',$headers);
 $to = str_replace('<','&lt;',$to);
 $to = str_replace('>','&gt;',$to);
 $mail = "<table border=1><tr><td><h3 style=\"margin:0px;\">HEADERS</h3>$headers<hr>To: $to<br>Subject: $subject<hr><h3 style=\"margin:0px;\">BODY</h3>$body<hr><h3 style=\"margin:0px;\">MESSAGE</h3>$message</td></tr></table><br><hr><br>";
 $mail = str_replace("\x0D", '', $mail);
 $mail = str_replace("\x0A", "<br>\n", $mail);
 echo $mail;
 }

$this->clear_headers();

 if($send_result){
 return true;
 }
 else{
 return false;
 }
}


public function is_valid_email($email){
 if(strstr($email, '\\')){
 return false;
 }
 if(preg_match('/^[a-z0-9_\.\-]{1,255}\@[a-z0-9\.\-]{1,255}$/i', $email)){
 return true;
 }
return false;
}


public function add_tolog($file, $data){
$fh = fopen($file,'ab') or die("Can't open $file\n");
flock($fh, LOCK_EX);
fputs($fh, $data);
flock($fh, LOCK_UN);
return fclose($fh);
}


public function add_header($header){
array_push($this->adv_headers, trim($header));
}


public function set_reply_to($name, $email){
$this->add_header('Reply-To: '.$this->encode_name_subject($name)." <$email>");
}


private function clear_headers(){
$this->adv_headers = array();
}


private function encode_name_subject($str){
return '=?'.$this->charset.'?B?'.base64_encode($str).'?=';
}


private function is_windows(){
 if(strtoupper(substr(PHP_OS, 0, 3)) == 'WIN'){
 return true;
 }
 else{
 return false;
 }
}


private function get_filename_from_full_path($full_path){
$full_path=str_replace('\\', '/', $full_path);
$full_path=' '.$full_path;
$pos=strrpos($full_path, '/');
return substr($full_path, $pos+1);
}


private function split_base64_text($text){
return rtrim(chunk_split($text, 76, "$this->crlf"));
}


private function generate_boundary(){
return substr(strtoupper(md5(rand(0,100000)).md5(rand(0,100000))), 0, 41);
}



}
?>