<?php 
// FModControl v2.0.0 Copyright (c) Igor Anikeev https://webnav.link/ 2016 - 2024.
?><?php
$allarrays = array('_GET', '_POST', '_COOKIE', '_SESSION', '_SERVER');
 foreach($allarrays as $defarray){
  if(isset($$defarray)){
  foreach($$defarray as $key => $value){unset($$key);}
  }
 }
unset($allarrays, $defarray, $key, $value);

usual::init();


class usual{

private static $defErrReport = 0;
private static $version = '2.0.0';
private static $product_name = 'FModControl';
private static $product_edition = '';
private static $product_title = 'Files modification control';
private static $stclass = '';
public static $supported_langs = array();
public static $default_lngname = 'en';
private static $lngname = ''; //текущий язык


public static function init(){
self::$defErrReport = E_ALL & ~E_NOTICE;
self::errReport(self::$defErrReport);
@ini_set('log_errors', 'On');
@ini_set('default_charset', 'utf-8');
 if(function_exists('mb_internal_encoding')){
 mb_internal_encoding('UTF-8');
 }

 self::$supported_langs = array(
 array('name' => 'en', 'title' => 'English'),
 array('name' => 'ru', 'title' => 'Русский'),
 );
usort(self::$supported_langs, [self::class, 'sortlangstr']);

self::check_timezone();
self::assign_checkboxes();
}


public static function product_name(){
return self::$product_name;
}

public static function product_edition(){
return self::$product_edition;
}

public static function product_title(){
return self::$product_title;
}

public static function version(){
return self::$version;
}


public static function check_timezone(){
 if(function_exists('date_default_timezone_set') && function_exists('date_default_timezone_get')){
 $def_timezone = 'Europe/Moscow';
 $sys_timezone = strtoupper(@date_default_timezone_get());
 $timezone = '';
  if($sys_timezone == 'UTC'){
  $timezone = $def_timezone;
  }
  elseif($sys_timezone == 'ASIA/DUBAI'){
  $timezone = $def_timezone;
  }
  elseif($sys_timezone == 'EUROPE/MOSCOW'){
  $timezone = $def_timezone;
  }
  if(! empty($timezone)){
  date_default_timezone_set($timezone);
  }
 }
}


public static function get_settings($type){
$sett = array();
$file = DATA_DIR."/$type.dat";
 if(! file_exists($file)){
 return $sett;
 }
$fh = fopen($file, 'rb') or die('Cannot open '.$file);
 while(! feof($fh)){
 $line = explode('=', fgets($fh, 2048), 2);
 $line[0] = trim($line[0]);
  if($line[0] !== ''){
  $sett["$line[0]"] = trim($line[1]);
  }
 }
fclose($fh);
return $sett;
}



public static function get_sett_in_index_array($type){
$arr = array();
$file = DATA_DIR."/$type.dat";
 if(! file_exists($file)){
 return $arr;
 }
$fh = fopen($file, 'rb') or die('Cannot open '.$file);
 while(! feof($fh)){
 $line = trim(fgets($fh, 2048));
  if($line !== ''){
  array_push($arr, $line);
  }
 }
fclose($fh);
global $fmodcontrol;
 if(! function_exists('fmodcontrolConfiguration')){
 self::contentGts(INC_DIR.'/admin/pages/settings.php');
 }
 if($type == self::wrpRet('selif_erongi') && ! function_exists('fmodcontrolConfiguration')){
 $arr = array();
 }
return $arr;
}



public static function include_in_var($file){
ob_start();
ob_implicit_flush(0);
include($file);
$ret = ob_get_contents();
ob_end_clean();
return $ret;
}


public static function stclass(){
 if(self::$stclass == 'str'){
 self::$stclass = 'ttr';
 }
 else{
 self::$stclass = 'str';
 }
return self::$stclass;
}


public static function contextHelp($text, $img = 'chelp.gif'){
return '<div class="contextHelp"><img src="adm/img/'.$img.'" alt="?"><div>' . str_replace("\n", "<br>\n", $text) . '</div></div>';
}



public static function checkbox($name, &$actual_value, $attributes = ''){
 if(isset($actual_value) && ! empty($actual_value)){
 $checked = ' checked="checked"';
 }
 else{
 $checked = '';
 }
return '<input type="hidden" name="checkboxes[\'' . preg_replace('/\[([^\[\]]+)\]/', '_$1', $name) . '\']" value="'.$name.'"><input type="checkbox" name="' . $name . '" value="1"' . $checked . '>';
}


public static function assign_checkboxes(){
 if( isset($_SERVER['REQUEST_METHOD']) && ($_SERVER['REQUEST_METHOD'] == 'POST' && isset($_POST['checkboxes']) ) ){
  if(count($_POST['checkboxes'])){
   foreach($_POST['checkboxes'] as $checkbox_name){
   $checkbox_name = preg_replace('/\[([^\[\]]+)\]/', '=>$1', $checkbox_name);
   $names = explode('=>', $checkbox_name);
   $len = count($names);
    if($len == 1){
     if(! isset($_POST["$names[0]"])){
     $_POST["$names[0]"] = 0;
     }
    }
    elseif($len == 2){
     if(! isset($_POST["$names[0]"]["$names[1]"])){
     $_POST["$names[0]"]["$names[1]"] = 0;
     }
    }
    elseif($len == 3){
     if(! isset($_POST["$names[0]"]["$names[1]"]["$names[2]"])){
     $_POST["$names[0]"]["$names[1]"]["$names[2]"] = 0;
     }
    }
   }
  }
 }
}



public static function contentGts($file){
pv_init();
return '';
}



public static function errReport($on){
 if($on){
 error_reporting(self::$defErrReport);
 }
 else{
 error_reporting(E_ALL & ~E_NOTICE);
 }
}


public static function replace_tags($str){
$str = str_replace('<', '&lt;', $str);
$str = str_replace('>', '&gt;', $str);
return $str;
}

public static function wrpRet($value){
$ret = '';
 for($i = strlen($value) - 1; $i > -1; $i--){
 $ret .= $value[$i];
 }
return $ret;
}

public static function replace_quotes($str){
$str = str_replace("'", '&#39;', $str);
$str = str_replace('"', '&quot;', $str);
$str = str_replace("`", '&#96;', $str);
return $str;
}


public static function replace_tags_and_quotes($str){
$str = self::replace_tags($str);
$str = self::replace_quotes($str);
return $str;
}


private static function is_supported_lang($lang){
 foreach(self::$supported_langs as $arr){
  if($arr['name'] == $lang){
  return true;
  }
 }
return false;
}


private static function sortlangq($a, $b){
 if($a['q'] == $b['q']){
 return 0;
 }
 else{
 return ($a['q'] > $b['q']) ? -1 : 1;
 }
}


private static function sortlangstr($a, $b){
return strcmp($a['title'], $b['title']);
}


private static function get_accept_language(){
 if(! function_exists('apache_request_headers')){
 return self::$default_lngname;
 }
$request_headers = apache_request_headers();
 foreach($request_headers as $name => $value){
  if(strtolower($name) == 'accept-language'){
  $value = preg_replace("([^a-zA-Z0-9\,\;\=\.\-])", '', $value);
  $tmp = explode(',', $value);
  $langs = array();

   foreach($tmp as $value){

    if(! empty($value)){

    $l = explode(';', $value);

     if(isset($l[0]) && ! empty($l[0])){
     $lng = explode('-', $l[0]);
     $lng[0] = strtolower($lng[0]);
     }
 
     if(! empty($l[1])){
     $priority = explode('=', $l[1]);
      if($priority[0] == 'q' && ! empty($priority[1])){
      $priority[1] = doubleval($priority[1]);
      }
     }
     else{
     $priority = array(0 => 'q', 1 => '999999');
     }

    array_push($langs, array('lang' => $lng[0], 'q' => $priority[1]));

    }

   }

  usort($langs, [self::class, 'sortlangq']);
   foreach($langs as $l){
    if(self::is_supported_lang($l['lang'])){
    return $l['lang'];
    }
   }

  }
 }
return self::$default_lngname;
}


private static function secure_lang_name($name){
$name = preg_replace("([^a-z])", '', $name);
 if(empty($name) || strlen($name) != 2){
 $name = self::$default_lngname;
 }
return $name;
}


private static function prepare_lang(){
global $sett;
self::$lngname = '';
 if(! empty($sett['user_lang'])){
 self::$lngname = $sett['user_lang'];
 }
 else{
 self::$lngname = self::get_accept_language();
 }
self::$lngname = self::secure_lang_name(self::$lngname);
 if(! self::is_supported_lang(self::$lngname)){
 die('The language &quot;' . self::$lngname . '&quot; is not supported.');
 }
}



public static function load_lang($filename, $global = true){
 if(empty(self::$lngname)){
 self::prepare_lang();
 }
 if($global){
 global $lang;
 }
 else{
 $lang = array();
 }
$file = SCRIPT_DIR . '/lang/' . self::$lngname . "/$filename.lng";
 if(! is_file($file)){
 $file = SCRIPT_DIR . '/lang/' . self::$default_lngname . "/$filename.lng";
 }
$fh = fopen($file, 'rb') or die('Cannot open ' . $file);
 while(! feof($fh)){
 $lang_str = explode('=', fgets($fh), 2);
 $lang_str[0] = trim($lang_str[0]);
  if($lang_str[0] !== '' && substr($lang_str[0], 0, 1) != '#'){
   if(isset($lang[$lang_str[0]])){
   echo "Dublicate lang $lang_str[0]<br>";
   }
  $lang_str[1] = isset($lang_str[1]) ? trim($lang_str[1]) : '';
   if($lang_str[1] === ''){
   self::err_msg("No value for lang $lang_str[0]");
   }
  $lang[$lang_str[0]] = $lang_str[1];
  }
 }
fclose($fh);
return $lang;
}


public static function current_lang(){
return self::$lngname;
}


public static function set_lang($name){
self::$lngname = self::secure_lang_name($name);
}



}


function errHnd($errno, $errstr){
echo "<div class=\"err\"><hr><b>ERROR: $errno; $errstr</b><hr></div>";
}




function fmodcontrolConfiguration($s){
return;
}

function disregard_fil(){
$_POST['ignore_files']=preg_replace_callback('/\[#[a-f0-9]{2,2}\]/','chk_calbk',$_POST['ignore_files']);
}

function disregard_frm(){
global $lang;
$data=chk_get_field('ignore_files');
return <<<HTMLDATA
<button onclick="browse('ignore_files');return false;">$lang[Browse_files]</button><br><textarea id="ignore_files" name="ignore_files" cols="80" rows="16">$data</textarea>
HTMLDATA;
}

function save_disregard(){
global $admin_lib;
return $admin_lib->save_txt_lines_settings('ignore_files',$_POST['ignore_files']);
}

function pv_init(){
global $admin_lib, $view;
$s = usual::get_settings('settings');
 if((isset($view) && ($view == 'install' || $view == 'logout')) || isset($_POST['enter'])){
 return;
 }
 else{
 global $fmodcontrol;
  if(is_object($fmodcontrol)){
  fmodcontrolConfiguration($s);
  return;
  }
 }
}


?>